Index: TOOLS/WATER_BUDGET/ATM_waterbudget.py
===================================================================
--- TOOLS/WATER_BUDGET/ATM_waterbudget.py	(revision 6446)
+++ TOOLS/WATER_BUDGET/ATM_waterbudget.py	(revision 6508)
@@ -396,141 +414,188 @@
 
 if Routing == 'SIMPLE' :
-    d_RUN_beg = xr.open_dataset ( os.path.join (TmpDir, file_RUN_beg), decode_times=False, decode_cf=True).squeeze()
-    d_RUN_end = xr.open_dataset ( os.path.join (TmpDir, file_RUN_end), decode_times=False, decode_cf=True).squeeze()
-    
-echo ( file_ATM_beg )
-echo ( file_ATM_end )
-echo ( file_DYN_beg )
-echo ( file_DYN_end )
-echo ( file_SRF_beg )
-echo ( file_SRF_end )
+    d_RUN_beg = xr.open_dataset ( os.path.join (RunDir, file_RUN_beg), decode_times=False, decode_cf=True ).squeeze()
+    d_RUN_end = xr.open_dataset ( os.path.join (RunDir, file_RUN_end), decode_times=False, decode_cf=True ).squeeze()
+
+def to_cell ( dd, newname='cell' ) :
+    '''Set space dimension to 'cell' '''
+    for oldname in [ 'cell_mesh', 'y', 'points_physiques' ] :
+        try    : dd = dd.rename ( {oldname : newname} )
+        except : pass
+    return dd
+
+d_ATM_beg = to_cell ( d_ATM_beg )
+d_ATM_end = to_cell ( d_ATM_end )
+d_SRF_beg = to_cell ( d_SRF_beg )
+d_SRF_end = to_cell ( d_SRF_end )
+d_DYN_beg = to_cell ( d_DYN_beg )
+d_DYN_end = to_cell ( d_DYN_end )
+
 if Routing == 'SIMPLE' :
-    echo ( file_RUN_beg )
-    echo ( file_RUN_end )
-
-##
+    d_RUN_beg = to_cell ( d_RUN_beg )
+    d_RUN_end = to_cell ( d_RUN_end )
+
+d_ATM_his = to_cell ( d_ATM_his )
+d_SRF_his = to_cell ( d_SRF_his )
+    
+echo ( f'{file_ATM_beg = }' )
+echo ( f'{file_ATM_end = }' )
+echo ( f'{file_DYN_beg = }' )
+echo ( f'{file_DYN_end = }' )
+echo ( f'{file_SRF_beg = }' )
+echo ( f'{file_SRF_end = }' )
+if Routing == 'SIMPLE' :
+    echo ( f'{file_RUN_beg = }' )
+    echo ( f'{file_RUN_end = }' )
+
+## Write the full configuration
 config_out = open (FullIniFile, 'w')
-config.write (config_out )
+config.write ( config_out )
 config_out.close ()
 
-def Ksum (tab) :
-    '''
-    Kahan summation algorithm, also known as compensated summation
-    https://en.wikipedia.org/wiki/Kahan_summation_algorithm
-    '''
-    Ksum = 0.0                   # Prepare the accumulator.
-    comp = 0.0                   # A running compensation for lost low-order bits.
-   
-    for xx in np.where ( np.isnan(tab), 0., tab ) : 
-        yy = xx - comp           # comp is zero the first time around.
-        tt = Ksum + yy           # Alas, sum is big, y small, so low-order digits of y are lost.
-        comp = (tt - Ksum) - yy  # (tt - Ksum) cancels the high-order part of y; subtracting y recovers negative (low part of yy)
-        Ksum = tt                # Algebraically, comp should always be zero. Beware overly-aggressive optimizing compilers!
-                                 # Next time around, the lost low part will be added to y in a fresh attempt.
-    return Ksum
-
-def Ssum (tab) :
-    '''
-    Precision summation by sorting by absolute value
-    '''
-    Ssum = np.sum ( tab[np.argsort(np.abs(tab))] )
-    return Ssum
-
-def KSsum (tab) :
-    '''
-    Precision summation by sorting by absolute value, and applying Kahan summation
-    '''
-    KSsum = Ksum ( tab[np.argsort(np.abs(tab))] )
-    return KSsum
-
-# Choosing algorithm
-Psum = KSsum
-
-def ATM_stock_int (stock) :
-    '''Integrate stock on atmosphere grid'''
-    ATM_stock_int  = Psum ( (stock * DYN_aire).to_masked_array().ravel() ) 
-    return ATM_stock_int
-
-def ATM_flux_int (flux) :
-    '''Integrate flux on atmosphere grid'''
-    ATM_flux_int  = Psum ( (flux * dtime_per_sec * ATM_aire).to_masked_array().ravel() )
-    return ATM_flux_int
-
-def SRF_stock_int (stock) :
-    '''Integrate stock on land grid'''
-    ATM_stock_int  = Ksum (  ( (stock * DYN_aire_fter).to_masked_array().ravel()) )
-    return ATM_stock_int
-
-def SRF_flux_int (flux) :
-    '''Integrate flux on land grid'''
-    SRF_flux_int  = Psum (  (flux * dtime_per_sec * SRF_aire).to_masked_array().ravel() )
-    return SRF_flux_int
-
-def ONE_stock_int (stock) :
-    '''Sum stock '''
-    ONE_stock_int  = Psum ( stock.to_masked_array().ravel() )
-    return ONE_stock_int
-
-def ONE_flux_int (flux) :
-    '''Sum flux '''
-    ONE_flux_int  = Psum ( (flux * dtime_per_sec ).to_masked_array().ravel() )
-    return ONE_flux_int
-
-def kg2Sv  (val, rho=ATM_rho) :
-    '''From kg to Sverdrup'''
-    return val/dtime_sec*1.0e-6/rho
-
-def kg2myear (val, rho=ATM_rho) :
-    '''From kg to m/year'''
-    return val/ATM_aire_sea_tot/rho/NbYear
-    
+if ICO :
+    if SortIco : 
+        # Creation d'une clef de tri pour les restarts (pour chaque restart !)
+        DYN_beg_keysort = np.lexsort ( (d_DYN_beg['lat_mesh'], d_DYN_beg['lon_mesh'] ) )
+        ATM_beg_keysort = np.lexsort ( (d_ATM_beg['latitude'], d_ATM_beg['longitude']) )
+        SRF_beg_keysort = np.lexsort ( (d_SRF_beg['nav_lat' ], d_SRF_beg['nav_lon']  ) )
+        DYN_end_keysort = np.lexsort ( (d_DYN_end['lat_mesh'], d_DYN_end['lon_mesh'] ) )
+        ATM_end_keysort = np.lexsort ( (d_ATM_end['latitude'], d_ATM_end['longitude']) )
+        SRF_end_keysort = np.lexsort ( (d_SRF_end['nav_lat' ], d_SRF_end['nav_lon']  ) )
+        
+        if ATM_HIS == 'ico' :
+            ATM_his_keysort = np.lexsort ( (d_ATM_his['lat'], d_ATM_his['lon'] ) )
+        if SRF_HIS == 'ico' :
+            SRF_his_keysort = np.lexsort ( (d_SRF_his['lat'], d_SRF_his['lon'] ) )
+            RUN_his_keysort = SRF_his_keysort
+    else : 
+        DYN_beg_keysort = np.arange ( len ( d_DYN_beg['lat_mesh'] ) )
+        ATM_beg_keysort = DYN_beg_keysort
+        SRF_beg_keysort = DYN_beg_keysort
+
+        DYN_end_keysort = DYN_beg_keysort
+        ATM_end_keysort = DYN_beg_keysort
+        SRF_end_keysort = DYN_beg_keysort
+    
+        ATM_his_keysort = DYN_beg_keysort
+        SRF_his_keysort = DYN_beg_keysort
+        RUN_his_keysort = SRF_his_keysort
+        
 # ATM grid with cell surfaces
+if LMDZ :
+    #ATM_lat  = lmdz.geo2point ( d_ATM_his ['lat']         , dim1D='cell' )
+    #ATM_lon  = lmdz.geo2point ( d_ATM_his ['lon']         , dim1D='cell' )
+    ATM_aire = lmdz.geo2point ( d_ATM_his ['aire']     [0], cumulPoles=True, dim1D='cell' )
+    ATM_fter = lmdz.geo2point ( d_ATM_his ['fract_ter'][0], dim1D='cell' )
+    ATM_foce = lmdz.geo2point ( d_ATM_his ['fract_oce'][0], dim1D='cell' )
+    ATM_fsic = lmdz.geo2point ( d_ATM_his ['fract_sic'][0], dim1D='cell' )
+    ATM_flic = lmdz.geo2point ( d_ATM_his ['fract_lic'][0], dim1D='cell' )
+    #SRF_lat  = lmdz.geo2point ( d_SRF_his ['lat']      [0], dim1D='cell' )
+    #SRF_lon  = lmdz.geo2point ( d_SRF_his ['lon']      [0], dim1D='cell' )
+    
+    #??SRF_aire = lmdz.geo2point ( d_SRF_his ['Areas'] * d_SRF_his ['Contfrac'], dim1D='cell' )
+    SRF_aire =  ATM_aire * lmdz.geo2point ( d_SRF_his['Contfrac'], dim1D='cell' )
+    
 if ICO :
-    jpja, jpia = d_ATM_his['aire'][0].shape   
-    file_ATM_aire = os.path.join ( R_IN, 'ATM', 'GRID', f'aire_{ATM}_to_{jpia}x{jpja}.nc' )
-    config['Files']['file_ATM_aire'] = file_ATM_aire
-    echo ( f'Aire sur grille reguliere : {file_ATM_aire}' )
-    d_ATM_aire = xr.open_dataset ( file_ATM_aire, decode_times=False ).squeeze()
-    ATM_aire = lmdz.geo2point ( d_ATM_aire ['aire'].squeeze(), cumulPoles=True )
-    ATM_fter = lmdz.geo2point ( d_ATM_his ['fract_ter'][0] )
-    ATM_foce = lmdz.geo2point ( d_ATM_his ['fract_oce'][0] )
-    ATM_fsic = lmdz.geo2point ( d_ATM_his ['fract_sic'][0] )
-    ATM_flic = lmdz.geo2point ( d_ATM_his ['fract_lic'][0] )
-    ATM_fsea = ATM_foce + ATM_fsic
-    ATM_flnd = ATM_fter + ATM_flic
-    SRF_aire = lmdz.geo2point ( d_SRF_his ['Areas'] * d_SRF_his ['Contfrac'] )
-    #SRF_aire = ATM_aire * lmdz.geo2point (d_SRF_his ['Contfrac'] )
-    #SRF_aire = ATM_aire * ATM_fter
-    
-if LMDZ :
-    ATM_aire = lmdz.geo2point ( d_ATM_his ['aire'][0], cumulPoles=True )
-    ATM_fsea = lmdz.geo2point ( d_ATM_his ['fract_oce'][0] + d_ATM_his ['fract_sic'][0] )
-    ATM_flnd = lmdz.geo2point ( d_ATM_his ['fract_ter'][0] )
-    #SRF_aire = lmdz.geo2point ( d_SRF_his['Areas'] * d_SRF_his['Contfrac'] )
-    SRF_aire = ATM_aire * lmdz.geo2point ( d_SRF_his['Contfrac'] )
-
-SRF_aire = SRF_aire.where ( SRF_aire < 1E15, 0.)
-
+    if ATM_HIS == 'latlon' :
+        jpja, jpia = d_ATM_his['aire'][0].shape   
+        file_ATM_aire = os.path.join ( R_IN, 'ATM', 'GRID', f'aire_{ATM}_to_{jpia}x{jpja}.nc' )
+        config['Files']['file_ATM_aire'] = file_ATM_aire
+        echo ( f'Aire sur grille reguliere : {file_ATM_aire = }' )
+        d_ATM_aire = xr.open_dataset ( file_ATM_aire, decode_times=False ).squeeze()
+        #ATM_lat  = d_ATM_his ['lat']
+        #ATM_lon  = d_ATM_his ['lon']
+        ATM_aire = lmdz.geo2point ( d_ATM_aire ['aire'].squeeze(), cumulPoles=True, dim1D='cell' )
+        ATM_fter = lmdz.geo2point ( d_ATM_his ['fract_ter'][0], dim1D='cell' )
+        ATM_foce = lmdz.geo2point ( d_ATM_his ['fract_oce'][0], dim1D='cell' )
+        ATM_fsic = lmdz.geo2point ( d_ATM_his ['fract_sic'][0], dim1D='cell' )
+        ATM_flic = lmdz.geo2point ( d_ATM_his ['fract_lic'][0], dim1D='cell' )
+        #SRF_lat  = d_SRF_his ['lat']
+        #SRF_lon  = d_SRF_his ['lon']
+        SRF_aire = lmdz.geo2point ( d_SRF_his ['Areas'] * d_SRF_his ['Contfrac'], dim1D='cell' )
+        
+    if ATM_HIS == 'ico' :
+        echo ( f'Grille icosaedre' )
+        ATM_aire =  d_ATM_his ['aire']     [0][ATM_his_keysort].squeeze()
+        #ATM_lat  =  d_ATM_his ['lat']         [ATM_his_keysort]
+        #ATM_lon  =  d_ATM_his ['lon']         [ATM_his_keysort]
+        ATM_fter =  d_ATM_his ['fract_ter'][0][ATM_his_keysort]
+        ATM_foce =  d_ATM_his ['fract_oce'][0][ATM_his_keysort]
+        ATM_fsic =  d_ATM_his ['fract_sic'][0][ATM_his_keysort]
+        ATM_flic =  d_ATM_his ['fract_lic'][0][ATM_his_keysort]
+        #SRF_lat  =  d_SRF_his ['lat']         [SRF_his_keysort]
+        #SRF_lon  =  d_SRF_his ['lon']         [SRF_his_keysort]
+        SRF_aire =  d_SRF_his ['Areas'][SRF_his_keysort] * d_SRF_his ['Contfrac'][SRF_his_keysort]
+
+ATM_fsea      = ATM_foce + ATM_fsic
+ATM_flnd      = ATM_fter + ATM_flic
+ATM_aire_fter = ATM_aire * ATM_fter
+ATM_aire_flic = ATM_aire * ATM_flic
+ATM_aire_fsic = ATM_aire * ATM_fsic
+ATM_aire_foce = ATM_aire * ATM_foce
+ATM_aire_flnd = ATM_aire * ATM_flnd
+ATM_aire_fsea = ATM_aire * ATM_fsea
+
+SRF_aire = SRF_aire.where ( np.abs (SRF_aire) < 1E15, 0.)
+            
 if ICO :
     # Area on icosahedron grid
-    file_DYN_aire = os.path.join ( R_IN, 'ATM', 'GRID', ATM+'_grid.nc' )
     d_DYN_aire = xr.open_dataset ( file_DYN_aire, decode_times=False).squeeze()
-    d_DYN_aire = d_DYN_aire.rename ( {'cell':'cell_mesh'} )
-    DYN_aire   = d_DYN_aire['aire']
-
-    DYN_fsea = d_DYN_aire ['fract_oce'] + d_DYN_aire ['fract_sic']
+
+    if SortIco : 
+        # Creation d'une clef de tri pour le fichier aire
+        DYN_aire_keysort = np.lexsort ( (d_DYN_aire['lat'], d_DYN_aire['lon']) )
+    else : 
+        DYN_aire_keysort = np.arange ( len ( d_DYN_aire['lat'] ) )
+            
+    DYN_lat = d_DYN_aire['lat'][DYN_aire_keysort]
+    DYN_lon = d_DYN_aire['lon'][DYN_aire_keysort]
+
+    DYN_aire = d_DYN_aire['aire'][DYN_aire_keysort]
+    DYN_fsea = d_DYN_aire ['fract_oce'][DYN_aire_keysort] + d_DYN_aire['fract_sic'][DYN_aire_keysort]
     DYN_flnd = 1.0 - DYN_fsea
-    DYN_fter = d_ATM_beg['FTER'].rename({'points_physiques':'cell_mesh'})
-    DYN_flic = d_ATM_beg['FTER'].rename({'points_physiques':'cell_mesh'})
+    DYN_fter = d_ATM_beg['FTER'][ATM_beg_keysort]
+    DYN_flic = d_ATM_beg['FLIC'][ATM_beg_keysort]
+    DYN_aire_fter = DYN_aire * DYN_fter
     
 if LMDZ :
+    # Area on lon/lat grid
     DYN_aire = ATM_aire
     DYN_fsea = ATM_fsea
     DYN_flnd = ATM_flnd
     DYN_fter = d_ATM_beg['FTER']
-    DYN_flic = d_ATM_beg['FTER']
-
-    
-DYN_aire_fter = DYN_aire * DYN_fter
+    DYN_flic = d_ATM_beg['FLIC']
+    DYN_aire_fter = DYN_aire * DYN_fter
+
+# Functions computing integrals and sum
+def ATM_stock_int (stock) :
+    '''Integrate (* surface) stock on atmosphere grid'''
+    ATM_stock_int  = wu.Psum ( (stock * DYN_aire).to_masked_array().ravel() ) 
+    return ATM_stock_int
+
+def ATM_flux_int (flux) :
+    '''Integrate (* time * surface) flux on atmosphere grid'''
+    ATM_flux_int  = wu.Psum ( (flux * dtime_per_sec * ATM_aire).to_masked_array().ravel() )
+    return ATM_flux_int
+
+def SRF_stock_int (stock) :
+    '''Integrate (* surface) stock on land grid'''
+    SRF_stock_int  = wu.Ksum (  ( (stock * DYN_aire_fter).to_masked_array().ravel()) )
+    return SRF_stock_int
+
+def SRF_flux_int (flux) :
+    '''Integrate (* time * surface) flux on land grid'''
+    SRF_flux_int  = wu.Psum (  (flux * dtime_per_sec * SRF_aire).to_masked_array().ravel() )
+    return SRF_flux_int
+
+def ONE_stock_int (stock) :
+    '''Sum stock '''
+    ONE_stock_int  = wu.Psum ( stock.to_masked_array().ravel() )
+    return ONE_stock_int
+
+def ONE_flux_int (flux) :
+    '''Integrate (* time) flux on area=1 grid '''
+    ONE_flux_int  = wu.Psum ( (flux * dtime_per_sec ).to_masked_array().ravel() )
+    return ONE_flux_int
+
 
 #if LMDZ :
@@ -538,14 +603,12 @@
 
 ATM_aire_sea     = ATM_aire * ATM_fsea
-ATM_aire_sea_tot = ONE_stock_int ( ATM_aire_sea )
-
 ATM_aire_tot     = ONE_stock_int (ATM_aire)
 ATM_aire_sea_tot = ONE_stock_int (ATM_aire*ATM_fsea)
 
 
-echo ( 'Aire atmosphere/4pi R^2 : {:12.5f}'.format(ATM_aire_tot/(Ra*Ra*4*np.pi) ) )
+echo ( 'Area of atmosphere/(4pi R^2) : {:12.5f}'.format(ATM_aire_tot/(Ra*Ra*4*np.pi) ) )
 
 if (  np.abs (ATM_aire_tot/(Ra*Ra*4*np.pi) - 1.0) > 0.01 ) :
-    raise Exception ('Erreur surface interpolee sur grille reguliere')
+    raise Exception ('Error of atmosphere surface interpolated on lon/lat grid')
 
 echo ( '\n====================================================================================' )
@@ -555,58 +618,59 @@
 #-- Compute sum weighted by gridcell area (kg/m2) then convert to Sv
 
-# ATM vertical grid
+echo ( 'ATM vertical grid' )
 ATM_Ahyb = d_ATM_his['Ahyb'].squeeze()
 ATM_Bhyb = d_ATM_his['Bhyb'].squeeze()
 
-# Surface pressure
-if ICO : 
-    DYN_psol_beg = d_DYN_beg['ps']
-    DYN_psol_end = d_DYN_end['ps']
+echo ( 'Surface pressure' )
+if ICO :
+    DYN_psol_beg = d_DYN_beg['ps'][DYN_beg_keysort]
+    DYN_psol_end = d_DYN_end['ps'][DYN_end_keysort]
 if LMDZ : 
-    DYN_psol_beg = lmdz.geo2point ( d_DYN_beg['ps'].isel(rlonv=slice(0,-1)) )
-    DYN_psol_end = lmdz.geo2point ( d_DYN_end['ps'].isel(rlonv=slice(0,-1)) )
-    
-# 3D Pressure at the interface layers (not scalar points)
+    DYN_psol_beg = lmdz.geo2point ( d_DYN_beg['ps'].isel(rlonv=slice(0,-1)), dim1D='cell' )
+    DYN_psol_end = lmdz.geo2point ( d_DYN_end['ps'].isel(rlonv=slice(0,-1)), dim1D='cell' )
+    
+echo ( '3D Pressure at the interface layers (not scalar points)' )
 DYN_pres_beg = ATM_Ahyb + ATM_Bhyb * DYN_psol_beg
 DYN_pres_end = ATM_Ahyb + ATM_Bhyb * DYN_psol_end
 
 klevp1 = ATM_Bhyb.shape[-1]
-if ICO  : cell_mesh        = DYN_psol_beg.shape[-1]
-if LMDZ : points_physiques = DYN_psol_beg.shape[-1]
+cell        = DYN_psol_beg.shape[-1]
 klev = klevp1 - 1
 
-# Layer thickness (pressure)
-if ICO : 
-    DYN_dpres_beg = xr.DataArray ( np.empty( (klev, cell_mesh       )), dims=('sigs', 'cell_mesh'       ), coords=(np.arange(klev), np.arange(cell_mesh)        ) )
-    DYN_dpres_end = xr.DataArray ( np.empty( (klev, cell_mesh       )), dims=('sigs', 'cell_mesh'       ), coords=(np.arange(klev), np.arange(cell_mesh)        ) )
-if LMDZ : 
-    DYN_dpres_beg = xr.DataArray ( np.empty( (klev, points_physiques)), dims=('sigs', 'points_physiques'), coords=(np.arange(klev), np.arange(points_physiques) ) )
-    DYN_dpres_end = xr.DataArray ( np.empty( (klev, points_physiques)), dims=('sigs', 'points_physiques'), coords=(np.arange(klev), np.arange(points_physiques) ) )
-
+echo ( 'Layer thickness (pressure)' )
+DYN_dpres_beg = xr.DataArray ( np.empty( (klev, cell )), dims = ('sigs', 'cell'), coords=(np.arange(klev), np.arange(cell) ) )
+DYN_dpres_end = xr.DataArray ( np.empty( (klev, cell )), dims = ('sigs', 'cell'), coords=(np.arange(klev), np.arange(cell) ) )
+#DYN_dpres_beg = DYN_dpres_beg
+#DYN_dpres_end = DYN_dpres_end
+    
 for k in np.arange (klevp1-1) :
     DYN_dpres_beg[k,:] = DYN_pres_beg[k,:] - DYN_pres_beg[k+1,:]
     DYN_dpres_end[k,:] = DYN_pres_end[k,:] - DYN_pres_end[k+1,:]
 
-##-- Vertical and horizontal integral, and sum of liquid, solid and vapor water phases
+echo ( 'Vertical and horizontal integral, and sum of liquid, solid and vapor water phases' )
 if LMDZ :
     try : 
-        DYN_wat_beg = lmdz.geo3point ( (d_DYN_beg['H2Ov']  + d_DYN_beg['H2Ol']  + d_DYN_beg['H2Oi'] ).isel(rlonv=slice(0,-1) ) )
-        DYN_wat_end = lmdz.geo3point ( (d_DYN_end['H2Ov']  + d_DYN_end['H2Ol']  + d_DYN_end['H2Oi'] ).isel(rlonv=slice(0,-1) ) )
+        DYN_wat_beg = lmdz.geo3point ( (d_DYN_beg['H2Ov']  + d_DYN_beg['H2Ol']  + d_DYN_beg['H2Oi'] ).isel(rlonv=slice(0,-1) ), dim1D='cell' )
+        DYN_wat_end = lmdz.geo3point ( (d_DYN_end['H2Ov']  + d_DYN_end['H2Ol']  + d_DYN_end['H2Oi'] ).isel(rlonv=slice(0,-1) ), dim1D='cell' )
     except :
-        DYN_wat_beg = lmdz.geo3point ( (d_DYN_beg['H2O_g'] + d_DYN_beg['H2O_l'] + d_DYN_beg['H2O_s']).isel(rlonv=slice(0,-1) ) )
-        DYN_wat_end = lmdz.geo3point ( (d_DYN_end['H2O_g'] + d_DYN_end['H2O_l'] + d_DYN_end['H2O_s']).isel(rlonv=slice(0,-1) ) )
+        DYN_wat_beg = lmdz.geo3point ( (d_DYN_beg['H2O_g'] + d_DYN_beg['H2O_l'] + d_DYN_beg['H2O_s']).isel(rlonv=slice(0,-1) ), dim1D='cell' )
+        DYN_wat_end = lmdz.geo3point ( (d_DYN_end['H2O_g'] + d_DYN_end['H2O_l'] + d_DYN_end['H2O_s']).isel(rlonv=slice(0,-1) ), dim1D='cell' )
 if ICO :
     try :
-        DYN_wat_beg = (d_DYN_beg['H2O_g'] + d_DYN_beg['H2O_l'] + d_DYN_beg['H2O_s']).rename ( {'lev':'sigs'} )
-        DYN_wat_end = (d_DYN_end['H2O_g'] + d_DYN_end['H2O_l'] + d_DYN_end['H2O_s']).rename ( {'lev':'sigs'} )
+        DYN_wat_beg = (d_DYN_beg['H2O_g'] + d_DYN_beg['H2O_l'] + d_DYN_beg['H2O_s'])[..., DYN_beg_keysort]
+        DYN_wat_end = (d_DYN_end['H2O_g'] + d_DYN_end['H2O_l'] + d_DYN_end['H2O_s'])[..., DYN_beg_keysort]
+        
     except : 
-        DYN_wat_beg = (d_DYN_beg['q'].isel(nq=0) + d_DYN_beg['q'].isel(nq=1) + d_DYN_beg['q'].isel(nq=2) ).rename ( {'lev':'sigs'} )
-        DYN_wat_end = (d_DYN_end['q'].isel(nq=0) + d_DYN_end['q'].isel(nq=1) + d_DYN_end['q'].isel(nq=2) ).rename ( {'lev':'sigs'} )
-    
-# Compute water content : vertical and horizontal integral
-DYN_mas_wat_beg = ATM_stock_int (DYN_dpres_beg * DYN_wat_beg) / Grav
-DYN_mas_wat_end = ATM_stock_int (DYN_dpres_end * DYN_wat_end) / Grav
-
-# Variation of water content
+        DYN_wat_beg = (d_DYN_beg['q'].isel(nq=0) + d_DYN_beg['q'].isel(nq=1) + d_DYN_beg['q'].isel(nq=2) )[..., DYN_beg_keysort]
+        DYN_wat_end = (d_DYN_end['q'].isel(nq=0) + d_DYN_end['q'].isel(nq=1) + d_DYN_end['q'].isel(nq=2) )[..., DYN_beg_keysort]
+        
+    DYN_wat_beg = DYN_wat_beg.rename ( {'lev':'sigs'} )
+    DYN_wat_beg = DYN_wat_end.rename ( {'lev':'sigs'} )
+    
+echo ( 'Compute water content : vertical and horizontal integral' )
+DYN_mas_wat_beg = ATM_stock_int ( (DYN_dpres_beg * DYN_wat_beg).sum (dim='sigs') ) / Grav
+DYN_mas_wat_end = ATM_stock_int ( (DYN_dpres_end * DYN_wat_end).sum (dim='sigs') ) / Grav
+
+echo ( 'Variation of water content' )
 dDYN_mas_wat = DYN_mas_wat_end - DYN_mas_wat_beg
 
@@ -614,31 +678,23 @@
 # \([a-z,A-Z,_]*\)\/ATM_aire_sea_tot\/ATM_rho\/NbYear  kg2myear(\1)
 
-def var2prt (var, small=False) :
-    if small :  return var , kg2Sv(var)*1000., kg2myear(var)*1000.
-    else     :  return var , kg2Sv(var)      , kg2myear(var)
-
-def prtFlux (Desc, var, Form='F', small=False) :
-    if small :
-        if Form in ['f', 'F'] : ff=" {:12.4e} kg | {:12.4f} mSv | {:12.4f} mm/year "
-        if Form in ['e', 'E'] : ff=" {:12.4e} kg | {:12.4e} mSv | {:12.4e} mm/year "
-    else :
-        if Form in ['f', 'F'] : ff=" {:12.4e} kg | {:12.4f} Sv  | {:12.4f} m/year  "
-        if Form in ['e', 'E'] : ff=" {:12.4e} kg | {:12.4e} Sv  | {:12.4e} m/year  "
-    echo ( (' {:>15} = ' +ff).format (Desc, *var2prt(var, small) ) )
-    return None
-
-echo ( f'\nVariation du contenu en eau atmosphere (dynamique)  -- {Title} ' )
+echo ( f'\nChange of atmosphere water content (dynamics)  -- {Title} ' )
 echo ( '------------------------------------------------------------------------------------' )
 echo ( 'DYN_mas_beg = {:12.6e} kg | DYN_mas_end = {:12.6e} kg'.format (DYN_mas_wat_beg, DYN_mas_wat_end) )
 prtFlux ( 'dMass (atm)  ', dDYN_mas_wat, 'e', True )
 
-ATM_sno_beg = d_ATM_beg['SNOW01']*d_ATM_beg['FTER']+d_ATM_beg['SNOW02']*d_ATM_beg['FLIC']+d_ATM_beg['SNOW03']*d_ATM_beg['FOCE']+d_ATM_beg['SNOW04']*d_ATM_beg['FSIC']
-ATM_sno_end = d_ATM_end['SNOW01']*d_ATM_end['FTER']+d_ATM_end['SNOW02']*d_ATM_end['FLIC']+d_ATM_end['SNOW03']*d_ATM_end['FOCE']+d_ATM_end['SNOW04']*d_ATM_end['FSIC']
-
-ATM_qs_beg  = d_ATM_beg['QS01']*d_ATM_beg['FTER']+d_ATM_beg['QS02']*d_ATM_beg['FLIC']+d_ATM_beg['QS03']*d_ATM_beg['FOCE']+d_ATM_beg['QS04']*d_ATM_beg['FSIC']
-ATM_qs_end  = d_ATM_end['QS01']*d_ATM_end['FTER']+d_ATM_end['QS02']*d_ATM_end['FLIC']+d_ATM_end['QS03']*d_ATM_end['FOCE']+d_ATM_end['QS04']*d_ATM_end['FSIC']
+ATM_sno_beg = d_ATM_beg['SNOW01']*d_ATM_beg['FTER'] + d_ATM_beg['SNOW02']*d_ATM_beg['FLIC'] + d_ATM_beg['SNOW03']*d_ATM_beg['FOCE'] + d_ATM_beg['SNOW04']*d_ATM_beg['FSIC']
+ATM_sno_end = d_ATM_end['SNOW01']*d_ATM_end['FTER'] + d_ATM_end['SNOW02']*d_ATM_end['FLIC'] + d_ATM_end['SNOW03']*d_ATM_end['FOCE'] + d_ATM_end['SNOW04']*d_ATM_end['FSIC']
+
+ATM_qs_beg  = d_ATM_beg['QS01']  *d_ATM_beg['FTER'] + d_ATM_beg['QS02']  *d_ATM_beg['FLIC'] + d_ATM_beg['QS03']  *d_ATM_beg['FOCE'] + d_ATM_beg['QS04']  *d_ATM_beg['FSIC']
+ATM_qs_end  = d_ATM_end['QS01']  *d_ATM_end['FTER'] + d_ATM_end['QS02']  *d_ATM_end['FLIC'] + d_ATM_end['QS03']  *d_ATM_end['FOCE'] + d_ATM_end['QS04']  *d_ATM_end['FSIC']
 
 ATM_qsol_beg = d_ATM_beg['QSOL']
 ATM_qsol_end = d_ATM_end['QSOL']
+
+LIC_sno_beg      = d_ATM_beg['SNOW02']*d_ATM_beg['FLIC']
+LIC_sno_end      = d_ATM_end['SNOW02']*d_ATM_end['FLIC']
+
+LIC_runlic0_beg  = d_ATM_beg['RUNOFFLIC0']
+LIC_runlic0_end  = d_ATM_end['RUNOFFLIC0']
 
 ATM_qs01_beg  = d_ATM_beg['QS01'] * d_ATM_beg['FTER']
@@ -651,34 +707,73 @@
 ATM_qs04_end  = d_ATM_end['QS04'] * d_ATM_end['FSIC']  
 
+# if LMDZ :
+#     ATM_sno_beg       = lmdz.geo2point ( ATM_sno_beg    , dim1D='cell' )
+#     ATM_sno_end       = lmdz.geo2point ( ATM_sno_end    , dim1D='cell' )
+#     ATM_qs_beg        = lmdz.geo2point ( ATM_qs_beg     , dim1D='cell' )
+#     ATM_qs_end        = lmdz.geo2point ( ATM_qs_end     , dim1D='cell' )
+#     ATM_qsol_beg      = lmdz.geo2point ( ATM_qsol_beg   , dim1D='cell' )
+#     ATM_qsol_end      = lmdz.geo2point ( ATM_qsol_end   , dim1D='cell' )
+#     ATM_qs01_beg      = lmdz.geo2point ( ATM_qs01_beg   , dim1D='cell' )
+#     ATM_qs01_end      = lmdz.geo2point ( ATM_qs01_end   , dim1D='cell' )
+#     ATM_qs02_beg      = lmdz.geo_point ( ATM_qs02_beg   , dim1D='cell' )
+#     ATM_qs02_end      = lmdz.geo2point ( ATM_qs02_end   , dim1D='cell' )
+#     ATM_qs03_beg      = lmdz.geo2point ( ATM_qs03_beg   , dim1D='cell' )
+#     ATM_qs03_end      = lmdz.geo2point ( ATM_qs03_end   , dim1D='cell' )
+#     ATM_qs04_beg      = lmdz.geo2point ( ATM_qs04_beg   , dim1D='cell' )
+#     ATM_qs04_end      = lmdz.geo2point ( ATM_qs04_end   , dim1D='cell' )
+#     LIC_sno_beg       = lmdz.geo2point ( LIC_sno_beg    , dim1D='cell' )
+#     LIC_sno_end       = lmdz.geo2point ( LIC_sno_end    , dim1D='cell' )
+#     LIC_runlic0_beg   = lmdz.geo2point ( LIC_runlic0_beg, dim1D='cell' )
+#     LIC_runlic0_end   = lmdz.geo2point ( LIC_runlic0_end, dim1D='cell' )
 if ICO :
-   ATM_sno_beg   = ATM_sno_beg .rename ( {'points_physiques':'cell_mesh'} )
-   ATM_sno_end   = ATM_sno_end .rename ( {'points_physiques':'cell_mesh'} )
-   ATM_qs_beg    = ATM_qs_beg  .rename ( {'points_physiques':'cell_mesh'} )
-   ATM_qs_end    = ATM_qs_end  .rename ( {'points_physiques':'cell_mesh'} )
-   ATM_qsol_beg  = ATM_qsol_beg.rename ( {'points_physiques':'cell_mesh'} )
-   ATM_qsol_end  = ATM_qsol_end.rename ( {'points_physiques':'cell_mesh'} )
-   ATM_qs01_beg  = ATM_qs01_beg.rename ( {'points_physiques':'cell_mesh'} )
-   ATM_qs01_end  = ATM_qs01_end.rename ( {'points_physiques':'cell_mesh'} )
-   ATM_qs02_beg  = ATM_qs02_beg.rename ( {'points_physiques':'cell_mesh'} )
-   ATM_qs02_end  = ATM_qs02_end.rename ( {'points_physiques':'cell_mesh'} )
-   ATM_qs03_beg  = ATM_qs03_beg.rename ( {'points_physiques':'cell_mesh'} )
-   ATM_qs03_end  = ATM_qs03_end.rename ( {'points_physiques':'cell_mesh'} )
-   ATM_qs04_beg  = ATM_qs04_beg.rename ( {'points_physiques':'cell_mesh'} )
-   ATM_qs04_end  = ATM_qs04_end.rename ( {'points_physiques':'cell_mesh'} ) 
-
-ATM_mas_sno_beg   = ATM_stock_int ( ATM_sno_beg  )
-ATM_mas_sno_end   = ATM_stock_int ( ATM_sno_end  )
-ATM_mas_qs_beg    = ATM_stock_int ( ATM_qs_beg   )
-ATM_mas_qs_end    = ATM_stock_int ( ATM_qs_end   )
-ATM_mas_qsol_beg  = ATM_stock_int ( ATM_qsol_beg )
-ATM_mas_qsol_end  = ATM_stock_int ( ATM_qsol_end )
-ATM_mas_qs01_beg  = ATM_stock_int ( ATM_qs01_beg )
-ATM_mas_qs01_end  = ATM_stock_int ( ATM_qs01_end )
-ATM_mas_qs02_beg  = ATM_stock_int ( ATM_qs02_beg )
-ATM_mas_qs02_end  = ATM_stock_int ( ATM_qs02_end )
-ATM_mas_qs03_beg  = ATM_stock_int ( ATM_qs03_beg )
-ATM_mas_qs03_end  = ATM_stock_int ( ATM_qs03_end )
-ATM_mas_qs04_beg  = ATM_stock_int ( ATM_qs04_beg )
-ATM_mas_qs04_end  = ATM_stock_int ( ATM_qs04_end )
+     ATM_sno_beg       = ATM_sno_beg    [ATM_beg_keysort]
+     ATM_sno_end       = ATM_sno_end    [ATM_end_keysort]
+     ATM_qs_beg        = ATM_qs_beg     [ATM_beg_keysort]
+     ATM_qs_end        = ATM_qs_end     [ATM_end_keysort]
+     ATM_qsol_beg      = ATM_qsol_beg   [ATM_beg_keysort]
+     ATM_qsol_end      = ATM_qsol_end   [ATM_end_keysort]
+     ATM_qs01_beg      = ATM_qs01_beg   [ATM_beg_keysort]
+     ATM_qs01_end      = ATM_qs01_end   [ATM_end_keysort]
+     ATM_qs02_beg      = ATM_qs02_beg   [ATM_beg_keysort]
+     ATM_qs02_end      = ATM_qs02_end   [ATM_end_keysort]
+     ATM_qs03_beg      = ATM_qs03_beg   [ATM_beg_keysort]
+     ATM_qs03_end      = ATM_qs03_end   [ATM_end_keysort]
+     ATM_qs04_beg      = ATM_qs04_beg   [ATM_beg_keysort]
+     ATM_qs04_end      = ATM_qs04_end   [ATM_end_keysort]
+     LIC_sno_beg       = LIC_sno_beg    [ATM_beg_keysort]
+     LIC_sno_end       = LIC_sno_end    [ATM_end_keysort]
+     LIC_runlic0_beg   = LIC_runlic0_beg[ATM_beg_keysort]
+     LIC_runlic0_end   = LIC_runlic0_end[ATM_end_keysort]
+
+
+   
+LIC_qs_beg = ATM_qs02_beg
+LIC_qs_end = ATM_qs02_end
+
+ATM_mas_sno_beg     = ATM_stock_int ( ATM_sno_beg  )
+ATM_mas_sno_end     = ATM_stock_int ( ATM_sno_end  )
+
+ATM_mas_qs_beg      = ATM_stock_int ( ATM_qs_beg   )
+ATM_mas_qs_end      = ATM_stock_int ( ATM_qs_end   )
+ATM_mas_qsol_beg    = ATM_stock_int ( ATM_qsol_beg )
+ATM_mas_qsol_end    = ATM_stock_int ( ATM_qsol_end )
+ATM_mas_qs01_beg    = ATM_stock_int ( ATM_qs01_beg )
+ATM_mas_qs01_end    = ATM_stock_int ( ATM_qs01_end )
+ATM_mas_qs02_beg    = ATM_stock_int ( ATM_qs02_beg )
+ATM_mas_qs02_end    = ATM_stock_int ( ATM_qs02_end )
+ATM_mas_qs03_beg    = ATM_stock_int ( ATM_qs03_beg )
+ATM_mas_qs03_end    = ATM_stock_int ( ATM_qs03_end )
+ATM_mas_qs04_beg    = ATM_stock_int ( ATM_qs04_beg )
+ATM_mas_qs04_end    = ATM_stock_int ( ATM_qs04_end )
+
+LIC_mas_sno_beg     = ATM_stock_int ( LIC_sno_beg     )
+LIC_mas_sno_end     = ATM_stock_int ( LIC_sno_end     )
+LIC_mas_runlic0_beg = ATM_stock_int ( LIC_runlic0_beg )
+LIC_mas_runlic0_end = ATM_stock_int ( LIC_runlic0_end )
+
+LIC_mas_qs_beg  = ATM_mas_qs02_beg
+LIC_mas_qs_end  = ATM_mas_qs02_end
+LIC_mas_wat_beg = LIC_mas_qs_beg + LIC_mas_sno_beg
+LIC_mas_wat_end = LIC_mas_qs_end + LIC_mas_sno_end
 
 dATM_mas_sno  = ATM_mas_sno_end  - ATM_mas_sno_beg
@@ -691,18 +786,20 @@
 dATM_mas_qs04 = ATM_mas_qs04_end - ATM_mas_qs04_beg
 
-dATM_mas_sno_2 = ATM_stock_int ( ATM_sno_end - ATM_sno_beg )
-
-echo ( f'\nVariation du contenu en neige atmosphere (calottes)  -- {Title} ' )
+dLIC_mas_qs      = LIC_mas_qs_end      - LIC_mas_qs_beg
+dLIC_mas_sno     = LIC_mas_sno_end     - LIC_mas_sno_beg
+dLIC_mas_runlic0 = LIC_mas_runlic0_end - LIC_mas_runlic0_beg
+dLIC_mas_wat     = dLIC_mas_qs + dLIC_mas_sno
+
+echo ( f'\nChange of atmosphere snow content (Land ice) -- {Title} ' )
 echo ( '------------------------------------------------------------------------------------' )
 echo ( 'ATM_mas_sno_beg  = {:12.6e} kg | ATM_mas_sno_end  = {:12.6e} kg'.format (ATM_mas_sno_beg, ATM_mas_sno_end) )
 prtFlux ( 'dMass (neige atm) ', dATM_mas_sno  , 'e', True  )
-prtFlux ( 'dMass (neige atm) ', dATM_mas_sno_2, 'e', True  )
-
-echo ( f'\nVariation du contenu humidite du sol  -- {Title} ' )
+
+echo ( f'\nChange of soil humidity content -- {Title} ' )
 echo ( '------------------------------------------------------------------------------------' )
 echo ( 'ATM_mas_qs_beg  = {:12.6e} kg | ATM_mas_qs_end  = {:12.6e} kg'.format (ATM_mas_qs_beg, ATM_mas_qs_end) )
 prtFlux ( 'dMass (neige atm) ', dATM_mas_qs, 'e', True )
 
-echo ( f'\nVariation du contenu en eau+neige atmosphere  -- {Title}  ' )
+echo ( f'\nChange of atmosphere water+snow content -- {Title}  ' )
 echo ( '------------------------------------------------------------------------------------' )
 prtFlux ( 'dMass (eau + neige atm) ', dDYN_mas_wat + dATM_mas_sno , 'e', True)
